/* $Copyright:	$
 * Copyright (c) 1984, 1985, 1986, 1987, 1988, 1989, 1990 
 * Sequent Computer Systems, Inc.   All rights reserved.
 *  
 * This software is furnished under a license and may be used
 * only in accordance with the terms of that license and with the
 * inclusion of the above copyright notice.   This software may not
 * be provided or otherwise made available to, or used by, any
 * other person.  No title to or ownership of the software is
 * hereby transferred.
*/

/*	Copyright (c) 1984 AT&T	*/
/*	  All Rights Reserved  	*/

/*	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T	*/
/*	The copyright notice above does not evidence any   	*/
/*	actual or intended publication of such source code.	*/

#ident	"$Header: ungetch.c 1.5 89/11/30 $@(#)curses:screen/ungetch.c	1.4"
#include "curses_inc.h"

/* Place a char onto the beginning of the input queue. */

ungetch(ch)
chtype ch;
{
    register	int	i = cur_term->_chars_on_queue, j = i - 1;
    register	chtype
			*inputQ = cur_term->_input_queue;

    /* Place the character at the beg of the Q */

    register chtype	r;
    if(ISCBIT(ch))
	{
	r = RBYTE(ch);
	ch = LBYTE(ch);
	/* do the right half first to maintain the byte order */
	if(r != MBIT && ungetch(r) == ERR)
		return ERR;
	}

    while (i > 0)
	inputQ[i--] = inputQ[j--];
    cur_term->_ungotten++;
    inputQ[0] = -ch;
    cur_term->_chars_on_queue++;
}
